// Written by TeTeT
// Duties of a CH-53 helo pilot on an invasion of N-Ziwasogo

waitUntil {alive player};

// Dummy function
TeTeT_getLZ = {
	params [ ["_excludeLZs", []] ];
	private ["_lzs", "_lz"];
	_lzs = [LZ1, LZ2, LZ3, LZ4];
	_lzs = _lzs - _excludeLZs;
	_lz = _lzs call bis_fnc_selectRandom;
	_lz;
};

TeTeT_fnc_callsign = {
	private ["_base", "_callsign"];
	// taken from hma1369tripod.com/callsigns.html
	_base = ["Antler", "Arctic Stone", "Atlas", "Avalanche", "Badger", "Barbarian", "Baseball", "Big Foot", "Big Iron",
	 "Big Mac", "Biloxi", "Biscuit", "Blanket", "Brazen", "Broil", "Cadaver", "Cartel", "Codfish", "Dimmer", "Deadly",
	 "Dusty", "Elusive", "Elvis", "Express", "Fisty", "Fringe", "Frosty", "Gopher", "Gunrunner", "Gunfighter",
	 "Haley", "Heroic", "Hummer", "Iron Horse", "Invincible", "Jewel", "Junkman"] call bis_fnc_selectRandom;
	 _callsign = format ["%1-%2%3", _base, floor random 9, floor random 9];
	 _callsign;
};

TeTeT_fnc_spawnGroup = {
	params [ ["_dest", player], ["_units", []] ];
	private ["_grp", "_wp"];
	_grp = [getPos _dest, west, _units] call BIS_fnc_spawnGroup;
	_grp setGroupId [[] call TeTeT_fnc_callsign];
	_wp = _grp addWaypoint [getPos _dest, 0];
	_wp setWaypointType "GUARD";
	_wp setWaypointBehaviour "SAFE";
	_wp setWaypointFormation "DIAMOND";
	_grp;
};

TeTeT_fnc_smoke = {
	params [ "_dest", ["_grp", ObjNull] ];
	private ["_ldr", "_pos", "_smoke"];

	_ldr = leader _grp;
	/*
	Does not work
	_flare = createVehicle ["F_20mm_Red", getPos _ldr, [], 0, "NONE"];
	_flare setPosATL [getPos _ldr select 0, getPos _ldr select 1, 100 + random(100)];
	_flare setVelocity [0,0,-0.1];
	*/
	// a lot of smoke
	{
		_pos = [_ldr, 10, random 360] call BIS_fnc_relPos;
		_smoke = "SmokeShellOrange" createVehicle _pos;
		_smoke setPosATL [_pos select 0, _pos select 1, 300];
		_smoke setDamage 1;
		sleep 0.1;
	} forEach [1, 2, 3, 4];

	_smoke = "SmokeShellGreen" createVehicle _pos;
	_smoke setPos [_pos select 0, _pos select 1, 1];
	_smoke setDamage 1;
	_ldr sideChat "Dropped smoke";
	_grp;
};

TeTeT_fnc_moveAway = {
	params ["_grp"];
	private ["_pos", "_wp"];

	_pos = [getPos (leader _grp), 500, 1500, 0, 0, 100, 0] call bis_fnc_findSafePos;
	_wp = _grp addWaypoint [_pos, 0];
	_wp setWaypointType "MOVE";
	_wp setWaypointFormation "COLUMN";
	_wp setWaypointBehaviour "SAFE";

	waitUntil {(leader _grp) distance _pos < 100};
	// Despawn when far away
	{ deleteVehicle _x; } forEach units _grp;
	_pos;
};

TeTeT_fnc_despawn = {
	params ["_veh", "_dest", ["_dist", 1000]];

	waitUntil {_veh distance _dest < _dist};
	{deleteVehicle _x} forEach crew _veh;
	deleteVehicle _veh;
	_dest;
};

TeTeT_fnc_boarding = {
	params ["_unit"];
	_unit sideChat (["Boarding", "Entering", "Getting in"] call bis_fnc_selectRandom);
	_unit;
};

TeTeT_fnc_in = {
	params ["_unit"];
	_unit sideChat (["Aboard", "Boarded", "All in", "Ready"] call bis_fnc_selectRandom);
	_unit;
};

TeTeT_fnc_out = {
	params ["_unit"];
	_unit sideChat (["Disembarking", "Leaving"] call bis_fnc_selectRandom);
	_unit;
};

TeTeT_fnc_thanks = {
	params ["_unit"];
	_unit sideChat (["Thanks", "Thanks for the ride", "Well done", "Good to be on the ground", "Merci", "Obliged"] call bis_fnc_selectRandom);
	_unit;
};

// Helper functions for packing and unpacking the helos, copied and refined from CUP

TeTeT_fnc_pack_CH53 = {
	params ["_heli", "_position", ["_instant", false]];

	_heli setfuel 1-_position;
	_heli animate ["Tailsection",_position, _instant];
	if (!_instant) then {
		sleep 10;
	};
	_heli animate ["mainrotor_folded",1-_position, _instant];
	_heli animate ["mainrotor_unfolded",_position, _instant];
	_heli;
};

TeTeT_fnc_pack_AH1Z = {
	params ["_ah1z", "_position", ["_instant", false]];

	_ah1z setfuel 1-_position;
	_ah1z animate ["mainrotor_folded",1-_position, _instant];
	_ah1z animate ["mainrotor_unfolded",_position, _instant];
	_ah1z animate ["rotorshaft_unfolded",_position, _instant];
	_ah1z;
};

TeTeT_fnc_pack_UH1Y = {
	params ["_heli", "_position", ["_instant", false]];

	_heli setfuel 1-_position;
	_heli animate ["mainrotor_folded",1-_position, _instant];
	_heli animate ["mainrotor_unfolded",_position, _instant];
	_heli animate ["rotorshaft_unfolded",_position, _instant];
	_heli;
};

[] execVM "fastrope.sqf";

[] execVM "functions\fn_main.sqf";
[] execVM "functions\fn_planes.sqf";
[] execVM "functions\fn_helos.sqf";
[] execVM "functions\fn_airfield.sqf";
[] execVM "functions\fn_lhd.sqf";