// Written by TeTeT
// Populate airfield with parked aircraft and helos and fly them away

private ["_hangars", "_heloparking", "_planeType", "_plane", "_heloType", "_helos", "_helo", "_pos", "_planes",
         "_dest", "_destinations", "_heloDestinations", "_grp", "_wp"];

_heloparking = [Helo1, Helo2, Helo3, Helo4, Helo5, Helo6];
_hangars = [Hangar1, Hangar2, Hangar3, Hangar4, Hangar5, Hangar6, Hangar7];
_destinations = [N, NE, E, SE, SW, W, NW];
_heloDestinations = _destinations;

TeTeT_freeHangar = _hangars call bis_fnc_selectRandom;
_hangars = _hangars - [ TeTeT_freeHangar ];
_planes = [];
{
	_planeType = ["CUP_B_AV8B_FFAR_7", "CUP_B_C130J_USMC", "CUP_B_MV22_USMC"] call bis_fnc_selectRandom;
	_plane = _planeType createVehicle (getPos _x);
	_plane setDir (getDir _x - 180);

	switch (_planeType) do {
		case "CUP_B_C130J_USMC" : {
			// need to move C130 in front of hangar, it's too big and can't take off
			_pos = [(getPos _x), 10, 180] call bis_fnc_relPos;
			_plane setPos _pos;
		};
		case "CUP_B_MV22_USMC": {
			// Same for Osprey as for Hercules
			_pos = [(getPos _x), 10, 180] call bis_fnc_relPos;
			_plane setPos _pos;
			// Osprey cannot take off either, only 1 in 5 work
			/*_planes pushBack _plane;*/
		};
		default {
			_planes pushBack _plane;
		};
	};

} forEach _hangars;

_helos = [];
{
	_heloType = ["CUP_B_MH60S_USMC", "CUP_B_AH1Z_Escort", "CUP_B_CH53E_USMC", "CUP_B_UH1Y_UNA_USMC"] call bis_fnc_selectRandom;
	_helo = _heloType createVehicle (getPos _x);
	_helo setDir (getDir _x - 180);
	_helos pushBack _helo;
} forEach _heloparking;

while {count _planes > 0 or count _helos > 0} do {

	if (count _helos > 0) then {
		_helo = _helos call bis_fnc_selectRandom;
		_helos = _helos - [ _helo ];
		createVehicleCrew _helo;

		_dest = _heloDestinations call bis_fnc_selectRandom;
		_grp = group (crew _helo select 0);
		_wp = _grp addWaypoint [_dest, 100];
		_wp setWaypointType "MOVE";

		[_helo, _dest] spawn {
			params ["_helo", "_dest"];
			waitUntil {_helo distance _dest < 1000};
			{deleteVehicle _x} forEach crew _helo;
			deleteVehicle _helo;
		};

		sleep 30;
	};

	if (count _planes > 0) then {
		_plane = _planes call bis_fnc_selectRandom;
		_planes = _planes - [ _plane ];
		createVehicleCrew _plane;

		_dest = _destinations call bis_fnc_selectRandom;
		_grp = group (crew _plane select 0);
		_wp = _grp addWaypoint [_dest, 100];
		_wp setWaypointType "MOVE";

		[_plane, _dest] spawn {
			params ["_plane", "_dest"];
			waitUntil {_plane distance _dest < 1000};
			{deleteVehicle _x} forEach crew _plane;
			deleteVehicle _plane;
		};

		sleep 30;
	};

};